package mpi.eudico.client.annotator.commands;

import mpi.eudico.client.annotator.Selection;
import mpi.eudico.client.annotator.export.ExportTeXDialog;

import mpi.eudico.server.corpora.clom.Transcription;


/**
 * A Command that brings up a dialog for tab delimited export.
 *
 * @author Han Sloetjes
 */
public class ExportTeXDlgCommand implements Command {
    private String commandName;

    /**
     * Creates a new ExportTabDelDlgCommand instance
     *
     * @param theName DOCUMENT ME!
     */
    public ExportTeXDlgCommand(String theName) {
        commandName = theName;
    }

    /**
     * <b>Note: </b>it is assumed the types and order of the arguments are
     * correct.
     *
     * @param receiver null
     * @param arguments the arguments:  <ul><li>arg[0] = the Transcription
     *        object(Transcription)</li> <li>arg[1] = the Selection object
     *        (Selection)</li> </ul>
     */
    public void execute(Object receiver, Object[] arguments) {
        new ExportTeXDialog(ELANCommandFactory.getRootFrame(
                (Transcription) arguments[0]), true,
            (Transcription) arguments[0], (Selection) arguments[1]).setVisible(true);
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getName() {
        return commandName;
    }
}
