package mpi.eudico.util;

import mpi.eudico.server.corpora.clom.ExternalReference;

/**
 * A class for an externally defined and stored controlled vocabulary, 
 * i.e. not part of the annotation document.
 *
 */
public class ExternalCV extends ControlledVocabulary {

    private ExternalReference externalRef;
    private boolean isLoadedFromURL;
    private boolean isLoadedFromCache;

	
	public ExternalCV(String name) {
		super(name);
	}

	public ExternalCV(ControlledVocabulary cv) {
		super(cv.getName());
		cloneStructure(cv);
		addAll(cv);
	}
	
//	public ExternalCV(String cvName, String extRefId) {
//		this(cvName);
//		setExternalRef(extRefId);
//	}

	public ExternalReference getExternalRef() {
		return externalRef;
	}

	public void setExternalRef(ExternalReference externalRef) {
		this.externalRef = externalRef;
	}
	
	
	protected void handleModified() {
		// do nothing, external CV's are not editable
	}

	public boolean isLoadedFromURL() {
		return isLoadedFromURL;
	}

	public void setLoadedFromURL(boolean isLoadedFromURL) {
		this.isLoadedFromURL = isLoadedFromURL;
	}

	public boolean isLoadedFromCache() {
		return isLoadedFromCache;
	}

	public void setLoadedFromCache(boolean isLoadedFromCache) {
		this.isLoadedFromCache = isLoadedFromCache;
	}
	
//	public ArrayList getSuggestions(String input) {
//		ArrayList suggestions = new ArrayList();
//		for(String entry: getEntryValues()) {
//			if(entry.startsWith(input)) {
//				suggestions.add(entry);
//			}
//		}
//		return suggestions;
//	}
}
